function FoxyTunesChromeToContentBridge() {
}

FoxyTunesChromeToContentBridge.prototype = {
    init: function(doc) {
        // Don't create the bridge more than once
        var foxyTunesBridge = doc.getElementById('FoxyTunesBridge');
        if (foxyTunesBridge) return;

        foxyTunesBridge = doc.createElement('div');
        foxyTunesBridge.id = 'FoxyTunesBridge';
        foxyTunesBridge.style.display = 'none';
        innerHTML = '';
        innerHTML += '<script type="application/x-javascript">'; 
        innerHTML += 'function foxytunesBridgeListener() {'; 
        innerHTML += '  var cmd = foxyTunesBridge.getAttribute("cmdToEval");'; 
        innerHTML += '  var rc = "";'; 
        innerHTML += '  try {'; 
        innerHTML += '      eval("rc = " + cmd);'; 
        innerHTML += '  } catch (e) {};'; 
        innerHTML += '  if ((typeof rc == "string") || (typeof rc == "number")) {';
        innerHTML += '      foxyTunesBridge.setAttribute("rc", rc);'; 
        innerHTML += '  } else {'; 
        innerHTML += '      foxyTunesBridge.setAttribute("rc", "");'; 
        innerHTML += '  }'; 
        innerHTML += '}'; 
        innerHTML += 'var foxyTunesBridge = document.getElementById("FoxyTunesBridge");';
        innerHTML += 'foxyTunesBridge.addEventListener("FTEvalCommand", foxytunesBridgeListener, true);';
        innerHTML += '</script>';

        foxyTunesBridge.innerHTML = innerHTML;
        doc.documentElement.appendChild(foxyTunesBridge);
    },

    fireCommand: function(doc, cmd) {
        // Just in case
     //   this.init(doc);

        var foxyTunesBridge = doc.getElementById('FoxyTunesBridge');
        if (!foxyTunesBridge) return;

        foxyTunesBridge.setAttribute('cmdToEval', cmd);
        var evt = doc.createEvent('Events');
        evt.initEvent('FTEvalCommand', true, false);
        foxyTunesBridge.dispatchEvent(evt); 
        var rc = foxyTunesBridge.getAttribute('rc');

        // Sanity
        foxyTunesBridge.setAttribute('cmdToEval', '');
        foxyTunesBridge.setAttribute('rc', '');

        return rc;
    },
}
